---
title: GlobalEventHandlers.ontransitioncancel
slug: Web/API/GlobalEventHandlers/ontransitioncancel
tags:
  - API
  - CSS Transitions
  - CSS3 Transitions
  - Event Handler
  - GlobalEventHandlers
  - Property
  - Reference
  - ontransitioncancel
---
<div>{{APIRef("CSS3 Transitions")}}</div>

<p>The <strong><code>ontransitioncancel</code></strong> property of the {{domxref("GlobalEventHandlers")}} mixin is an {{domxref("EventHandler")}} that processes {{event("transitioncancel")}} events.</p>

<p>The <code>transitioncancel</code> event is sent when a <a href="/en-US/docs/Web/CSS/CSS_Transitions">CSS transition</a> is cancelled. The transition is cancelled when:</p>

<ul>
 <li>The value of the {{cssxref("transition-property")}} property that applies to the target is changed</li>
 <li>The {{cssxref("display")}} property is set to <code>"none"</code>.</li>
 <li>The transition is stopped before it has run to completion, e.g. by moving the mouse off a hover-transitioning element.</li>
</ul>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">var <var>transitionCancelHandler</var> = <var>target</var>.ontransitioncancel;

<var>target</var>.ontransitioncancel = <var>{{jsxref("Function")}}</var>
</pre>

<h3 id="Value">Value</h3>

<p>A {{jsxref("Function")}} to be called when a {{event("transitioncancel")}} event occurs indicating that a CSS transition has been cancelled on the <code><var>target</var></code>, where the target object is an HTML element ({{domxref("HTMLElement")}}), document ({{domxref("Document")}}), or window ({{domxref("Window")}}). The function receives as input a single parameter: a {{domxref("TransitionEvent")}} object describing the event which occurred; the event's {{domxref("TransitionEvent.elapsedTime")}} property's value should be the same as the value of {{cssxref("transition-duration")}}.</p>

<div class="note">
<p><strong>Note</strong>: <code>elapsedTime</code> does not include time prior to the transition effect beginning; that means that the value of {{cssxref("transition-delay")}} doesn't affect the value of <code>elapsedTime</code>, which is zero until the delay period ends and the animation begins.</p>
</div>

<h2 id="Example">Example</h2>

<p>In this example, we use the {{event("transitionrun")}} and {{event("transitionend")}} events to detect when the transition begins and ends, to cause a text update to occur during the transition. This could also be used to trigger animations or other effects, to allow chaining of reactions.</p>

<p>In addition, we also use a {{event("click")}} event to make the box dissappear (<code>display: none;</code>), showing how it triggers the {{event("transitioncancel")}} event to fire.</p>

<h3 id="HTML">HTML</h3>

<p>This creates a {{HTMLElement("div")}} which we'll style with CSS below to make into a box that resizes and changes color and such.</p>

<pre class="brush: html; notranslate">&lt;div class="box"&gt;&lt;/div&gt;
</pre>

<h3 id="CSS">CSS</h3>

<p>The CSS below styles the box and applies a transition effect which makes the box's color and size change, and causes the box to rotate, while the mouse cursor hovers over it.</p>

<pre class="brush: css; highlight:[13,14] notranslate">.box {
  margin-left: 70px;
  margin-top: 30px;
  border-style: solid;
  border-width: 1px;
  display: block;
  width: 100px;
  height: 100px;
  background-color: #0000FF;
  color: #FFFFFF;
  padding: 20px;
  font: bold 1.6em "Helvetica", "Arial", sans-serif;
  -webkit-transition: width 2s, height 2s, background-color 2s, -webkit-transform 2s, color 2s;
  transition: width 2s, height 2s, background-color 2s, transform 2s, color 2s;
}

.box:hover {
  background-color: #FFCCCC;
  color: #000000;
  width: 200px;
  height: 200px;
  -webkit-transform: rotate(180deg);
  transform: rotate(180deg);
}
</pre>

<h3 id="JavaScript">JavaScript</h3>

<p>Next, we need to establish our event handlers to change the text content of the box when the transition begins and ends.</p>

<pre class="brush: js notranslate">let box = document.querySelector(".box");
box.ontransitionrun = function(event) {
  box.textContent = "Zooming...";
}
box.ontransitionend = function(event) {
  box.textContent = "Done!";
}

box.onclick = function() {
  box.style.display = 'none';
  timeout = window.setTimeout(appear, 2000);
  function appear() {
    box.style.display = 'block';
  }
}

box.ontransitioncancel = function(event) {
  console.log('transitioncancel fired after ' + event.<code>elapsedTime + ' seconds.'</code>);
}</pre>

<h3 id="Result">Result</h3>

<p>The resulting content looks like this:</p>

<p>{{EmbedLiveSample('Example', 600, 280)}}</p>

<p>Notice what happens when you hover your mouse cursor over the box, then move it away.</p>

<p>Also note the log that appears in the JavaScript console when you click the box, or move the cursor away before the transition has run to completion.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('CSS3 Transitions','#dom-globaleventhandlers-ontransitioncancel','ontransitioncancel')}}</td>
   <td>{{Spec2('CSS3 Transitions')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.GlobalEventHandlers.ontransitioncancel")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>The {{event("transitioncancel")}} event this event handler is triggered by</li>
 <li>{{domxref("TransitionEvent")}}</li>
 <li>The {{event("transitionrun")}} event, which occurs when the transition begins</li>
</ul>
